package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationDeptBusinessPlanMapper;
import com.ims.eval.entity.EvaluationDeptBusinessPlan;
import com.ims.eval.service.IEvaluationDeptBusinessPlanService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author hlf
 * @date 2023/4/27 10:33
 * 文件说明：
 */
@Service
public class EvaluationDeptBusinessPlanServiceImpl extends ServiceImpl<EvaluationDeptBusinessPlanMapper, EvaluationDeptBusinessPlan> implements IEvaluationDeptBusinessPlanService {

	@Override
	public IPage<EvaluationDeptBusinessPlan> listPage(Integer pageNum, Integer pageSize, String responsibilityCode, String des, String appraisalYear) {
		if (null == pageNum || null == pageSize) {
			throw new RuntimeException("分页参数为空");
		}
		//构造分页构造器
		Page<EvaluationDeptBusinessPlan> page = new Page<>(pageNum, pageSize);
		return baseMapper.selectListPage(page, responsibilityCode, des, appraisalYear);
	}

	@Override
	public List<EvaluationDeptBusinessPlan> listAll(String responsibilityCode, String des, String appraisalYear) {
		QueryWrapper<EvaluationDeptBusinessPlan> qw = new QueryWrapper<>();

		if (StringUtils.isNotEmpty(responsibilityCode)) {
			qw.lambda().eq(EvaluationDeptBusinessPlan::getResponsibilityCode, responsibilityCode);
		}

		if (StringUtils.isNotEmpty(des)) {
			qw.lambda().eq(EvaluationDeptBusinessPlan::getDes, des);
		}

		if (StringUtils.isNotEmpty(appraisalYear)) {
			qw.lambda().eq(EvaluationDeptBusinessPlan::getAppraisalYear, appraisalYear);
		}

		return baseMapper.selectList(qw);
	}

	@Override
	public boolean editState(String id, String state, String instId) {
		EvaluationDeptBusinessPlan evaluationDeptBusinessPlan = baseMapper.selectById(id);
		if (StringUtils.isNotEmpty(state)) {
			evaluationDeptBusinessPlan.setStage(state);
		}
		if (StringUtils.isNotEmpty(instId)) {
			evaluationDeptBusinessPlan.setInstId(instId);
		}
		return super.saveOrUpdate(evaluationDeptBusinessPlan);
	}
}
