package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ims.common.utils.StringUtils;
import com.ims.eval.entity.EvaluateRule;
import com.ims.eval.entity.EvaluationDept;
import com.ims.eval.dao.EvaluationDeptMapper;
import com.ims.eval.service.IEvaluationDeptService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collection;
import java.util.List;

/**
 * <p>
 * 考评部门 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-03-06
 */
@Service
public class EvaluationDeptServiceImpl extends ServiceImpl<EvaluationDeptMapper, EvaluationDept> implements IEvaluationDeptService {

	@Transactional
	@Override
	public boolean saveOrUpdate(EvaluationDept entity) {
		boolean b = false;

		b = super.saveOrUpdate(entity);

		return b;
	}

	@Override
	public List<EvaluationDept> listAll(String deptId, String annual) {
		return baseMapper.selectListAll(deptId, annual);
	}

	@Override
	public IPage<EvaluationDept> listPage(Integer pageNum, Integer pageSize, String deptName, String annual) {
		if (null == pageNum || null == pageSize) {
			throw new RuntimeException("分页参数为空");
		}
		//构造分页构造器
		Page<EvaluationDept> page = new Page<>(pageNum, pageSize);
		return baseMapper.selectListPage(page, deptName, annual);
	}

	@Transactional
	@Override
	public boolean saveBatch(Collection<EvaluationDept> entityList) {
		boolean b = super.saveBatch(entityList);
		return b;
	}
}
